-- Author:modelleicher
-- Name:Place Utility Pole Wires (EasyFence)
-- Description: see below
-- Icon:
-- Hide: no

-- description:
-- Used to create wire fences. Tutorial on how to use it can be found on
-- Youtube
-- English tutorial: https://youtu.be/5A52A99n3j4
-- German tutorial: https://youtu.be/PjL5eJOCidI

-- DO NOT MODIFY THE NEXT 3 LINES IF YOU NOT KNOW WHAT YOU ARE DOING
function vector3Length(x,y,z)
return math.sqrt(x*x + y*y + z*z);
end;

-- THESE ARE THE VARIABLES YOU NEED TO MODIFY TO USE
E_wireNodesCnt = 3; -- the number of wire nodes on each post (need to be the same on all posts)

E_fenceWire = 2381; -- Node ID of the fence wire object
E_startWireLength = 91; -- length of the wire non-scaled (put child transform in wire and move to other end, read translation value)

E_fenceTransform = 2378; -- Node ID of the actual fence transform containing the fence posts

E_maxPosts = 82; -- max. number of poles you want the fence script to add the fence to
E_startPost = 0; -- number of the pole you want to start the wire (normal 0 -> start at top) but in case you want to do a larger fence in sections

-- DO NOT MODIFY ANYTHING BELOW IF YOU DON'T KNOW WHAT YOU ARE DOING
for i = E_startPost, E_maxPosts do

    local post = getChildAt(E_fenceTransform, i);
    local nextPost = getChildAt(E_fenceTransform, math.min(i+1, E_maxPosts));

    -- do all the wire things for each wire.. As we start with 0 its nodesCnt -1 = max
    for x = 0, E_wireNodesCnt-1 do

        local wireNode = getChildAt(post, x);

        local newWireNode = getChildAt(nextPost, x);

        local newWireObject = clone(E_fenceWire, false, false, false);
        link(wireNode, newWireObject);
        setTranslation(newWireObject, 0, 0, 0);
        setRotation(newWireObject, 0, 0, 0);

        local ax, ay, az = getWorldTranslation(newWireObject);
        local bx, by, bz = getWorldTranslation(newWireNode);
        x, y, z = worldDirectionToLocal(getParent(newWireObject), bx-ax, by-ay, bz-az);
        local upx, upy, upz = 0,1,0;

        setDirection(newWireObject, x, y, z, upx, upy, upz);

        local distance = vector3Length(ax-bx, ay-by, az-bz);
        local scaleX, scaleY, scaleZ = getScale(newObj);
        local setScaleWert = 1 * (distance / E_startWireLength);
        setScale(newWireObject, 1, 1, setScaleWert);
    end;
end;
print("Finished! Enjoy the fence :) ");
